Index: /code/branches/objecthierarchy/init/common/def_keybindings.ini
===================================================================
--- /code/branches/objecthierarchy/init/common/def_keybindings.ini	(revision 2012)
+++ /code/branches/objecthierarchy/init/common/def_keybindings.ini	(revision 2013)
@@ -40,5 +40,5 @@
 KeyF8=
 KeyF9=
-KeyG=
+KeyG=greet
 KeyGrave="openConsole"
 KeyH=
Index: /code/branches/objecthierarchy/src/core/ArgumentCompletionFunctions.cc
===================================================================
--- /code/branches/objecthierarchy/src/core/ArgumentCompletionFunctions.cc	(revision 2012)
+++ /code/branches/objecthierarchy/src/core/ArgumentCompletionFunctions.cc	(revision 2013)
@@ -30,5 +30,5 @@
 #include <map>
 
-#include "boost/filesystem.hpp"
+#include <boost/filesystem.hpp>
 
 #include "ArgumentCompletionFunctions.h"
Index: /code/branches/objecthierarchy/src/core/Template.cc
===================================================================
--- /code/branches/objecthierarchy/src/core/Template.cc	(revision 2012)
+++ /code/branches/objecthierarchy/src/core/Template.cc	(revision 2013)
@@ -27,5 +27,4 @@
  */
 
-#include "OrxonoxStableHeaders.h"
 #include "Template.h"
 
Index: /code/branches/objecthierarchy/src/orxonox/OrxonoxStableHeaders.h
===================================================================
--- /code/branches/objecthierarchy/src/orxonox/OrxonoxStableHeaders.h	(revision 2012)
+++ /code/branches/objecthierarchy/src/orxonox/OrxonoxStableHeaders.h	(revision 2013)
@@ -37,5 +37,5 @@
 #include "util/OrxonoxPlatform.h"
 
-#if ORXONOX_COMPILER == ORXONOX_COMPILER_MSVC && !defined(ORXONOX_DISABLE_PCH)
+#if defined(ORXONOX_ENABLE_PCH)
 
 // including std headers here is useless since they're already precompiled
@@ -47,13 +47,15 @@
 #include <Ogre.h>
 #include <CEGUI.h>
+#include "ois/OIS.h"
 #include <boost/thread/recursive_mutex.hpp>
-#include <boost/thread/mutex.hpp>
-#include <boost/thread/condition.hpp>
-#include <boost/thread/thread.hpp>
-
+//#include <boost/thread/mutex.hpp>
+//#include <boost/thread/condition.hpp>
+//#include <boost/thread/thread.hpp>
+#include <boost/static_assert.hpp>
 #include "tinyxml/ticpp.h"
 #include "tinyxml/tinyxml.h"
+#include "tolua/tolua++.h"
 
-//Get around Windows hackery (windows.h is included by Ogre)
+//Get around Windows hackery (windows.h is included by Ogre.h)
 #if ORXONOX_PLATFORM == ORXONOX_PLATFORM_WIN32 
 #  ifdef max
@@ -67,13 +69,12 @@
 //----------- Our files ----------
 //--------------------------------
-// only include when not debugging so that we may find issues with missing headers quicker
-#if defined(NDEBUG)
+//// only include when not debugging so that we may find issues with missing headers quicker
+//#if defined(NDEBUG)
 
 #include "util/Convert.h"
 #include "util/Debug.h"
+#include "util/Exception.h"
 #include "util/Math.h"
 #include "util/Multitype.h"
-#include "util/OutputBuffer.h"
-#include "util/OutputHandler.h"
 #include "util/Sleep.h"
 #include "util/String.h"
@@ -85,17 +86,18 @@
 #include "core/ConfigValueIncludes.h"
 #include "core/CommandExecutor.h"
+#include "core/Core.h"
 #include "core/Executor.h"
+#include "core/ObjectList.h"
+#include "core/Super.h"
 #include "core/XMLIncludes.h"
 #include "core/XMLPort.h"
+#include "core/input/SimpleInputState.h"
+#include "core/input/InputManager.h"
 
 #include "network/Synchronisable.h"
 
-//#include "tools/Mesh.h"
-//#include "tools/Timer.h"
-//#include "objects/Model.h"
-//#include "objects/Tickable.h"
-//#include "objects/WorldEntity.h"
+#include "Settings.h"
 
-#endif /* ifdef NDEBUG */
+//#endif /* ifdef NDEBUG */
 
 #endif /* ORXONOX_COMPILER == ORXONOX_COMPILER_MSVC && !defined(ORXONOX_DISABLE_PCH) */
Index: /code/branches/objecthierarchy/src/orxonox/gamestates/GSGraphics.cc
===================================================================
--- /code/branches/objecthierarchy/src/orxonox/gamestates/GSGraphics.cc	(revision 2012)
+++ /code/branches/objecthierarchy/src/orxonox/gamestates/GSGraphics.cc	(revision 2013)
@@ -489,6 +489,6 @@
             it->windowResized(this->renderWindow_->getWidth(), this->renderWindow_->getHeight());
 
-		// OIS needs this under linux even if we only use relative input measurement.
-		if (this->inputManager_)
+        // OIS needs this under linux even if we only use relative input measurement.
+        if (this->inputManager_)
             this->inputManager_->setWindowExtents(renderWindow_->getWidth(), renderWindow_->getHeight());
     }
@@ -506,5 +506,5 @@
 
         // instruct InputManager to clear the buffers (core library so we cannot use the interface)
-		if (this->inputManager_)
+        if (this->inputManager_)
             this->inputManager_->clearBuffers();
     }
@@ -518,6 +518,4 @@
     void GSGraphics::windowClosed(Ogre::RenderWindow *rw)
     {
-        // using CommandExecutor in order to avoid depending on Orxonox.h.
-        //CommandExecutor::execute("exit", false);
         this->requestState("root");
     }
Index: /code/branches/objecthierarchy/src/orxonox/gamestates/GSIOConsole.cc
===================================================================
--- /code/branches/objecthierarchy/src/orxonox/gamestates/GSIOConsole.cc	(revision 2012)
+++ /code/branches/objecthierarchy/src/orxonox/gamestates/GSIOConsole.cc	(revision 2013)
@@ -36,5 +36,4 @@
 
 #include "core/ConsoleCommand.h"
-#include "core/TclThreadManager.h"
 #include "GraphicsEngine.h"
 
Index: /code/branches/objecthierarchy/src/orxonox/gui/OgreCEGUIRenderer.cpp
===================================================================
--- /code/branches/objecthierarchy/src/orxonox/gui/OgreCEGUIRenderer.cpp	(revision 2012)
+++ /code/branches/objecthierarchy/src/orxonox/gui/OgreCEGUIRenderer.cpp	(revision 2013)
@@ -25,4 +25,5 @@
 *************************************************************************/
 
+#include "OrxonoxStableHeaders.h"
 #include <CEGUIImagesetManager.h>
 #include <CEGUIImageset.h>
Index: /code/branches/objecthierarchy/src/orxonox/gui/OgreCEGUIResourceProvider.cpp
===================================================================
--- /code/branches/objecthierarchy/src/orxonox/gui/OgreCEGUIResourceProvider.cpp	(revision 2012)
+++ /code/branches/objecthierarchy/src/orxonox/gui/OgreCEGUIResourceProvider.cpp	(revision 2013)
@@ -24,4 +24,5 @@
     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *************************************************************************/
+#include "OrxonoxStableHeaders.h"
 #include "OgreCEGUIResourceProvider.h"
 
Index: /code/branches/objecthierarchy/src/orxonox/gui/OgreCEGUITexture.cpp
===================================================================
--- /code/branches/objecthierarchy/src/orxonox/gui/OgreCEGUITexture.cpp	(revision 2012)
+++ /code/branches/objecthierarchy/src/orxonox/gui/OgreCEGUITexture.cpp	(revision 2013)
@@ -25,4 +25,5 @@
 *************************************************************************/
 
+#include "OrxonoxStableHeaders.h"
 #include <CEGUISystem.h>
 #include <CEGUIExceptions.h>
Index: /code/branches/objecthierarchy/src/orxonox/objects/Trigger.h
===================================================================
--- /code/branches/objecthierarchy/src/orxonox/objects/Trigger.h	(revision 2012)
+++ /code/branches/objecthierarchy/src/orxonox/objects/Trigger.h	(revision 2013)
@@ -36,6 +36,5 @@
 
 #include "worldentities/PositionableEntity.h"
-
-#include "../tools/BillboardSet.h"
+#include "tools/BillboardSet.h"
 
 namespace orxonox {
Index: /code/branches/objecthierarchy/visual_studio/vc8/core.vcproj
===================================================================
--- /code/branches/objecthierarchy/visual_studio/vc8/core.vcproj	(revision 2012)
+++ /code/branches/objecthierarchy/visual_studio/vc8/core.vcproj	(revision 2013)
@@ -604,8 +604,4 @@
 				</File>
 				<File
-					RelativePath="..\..\src\core\Level.h"
-					>
-				</File>
-				<File
 					RelativePath="..\..\src\core\Loader.h"
 					>
@@ -617,4 +613,8 @@
 				<File
 					RelativePath="..\..\src\core\NamespaceNode.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\XMLFile.h"
 					>
 				</File>
Index: /code/branches/objecthierarchy/visual_studio/vc8/network.vcproj
===================================================================
--- /code/branches/objecthierarchy/visual_studio/vc8/network.vcproj	(revision 2012)
+++ /code/branches/objecthierarchy/visual_studio/vc8/network.vcproj	(revision 2013)
@@ -149,4 +149,8 @@
 			>
 			<File
+				RelativePath="..\..\src\network\ChatListener.cc"
+				>
+			</File>
+			<File
 				RelativePath="..\..\src\network\Client.cc"
 				>
@@ -235,4 +239,8 @@
 			>
 			<File
+				RelativePath="..\..\src\network\ChatListener.h"
+				>
+			</File>
+			<File
 				RelativePath="..\..\src\network\Client.h"
 				>
Index: /code/branches/objecthierarchy/visual_studio/vc8/orxonox.vcproj
===================================================================
--- /code/branches/objecthierarchy/visual_studio/vc8/orxonox.vcproj	(revision 2012)
+++ /code/branches/objecthierarchy/visual_studio/vc8/orxonox.vcproj	(revision 2013)
@@ -39,5 +39,4 @@
 			<Tool
 				Name="VCCLCompilerTool"
-				AdditionalOptions="/Zm200"
 			/>
 			<Tool
@@ -103,5 +102,4 @@
 			<Tool
 				Name="VCCLCompilerTool"
-				AdditionalOptions="/Zm200"
 			/>
 			<Tool
@@ -275,5 +273,5 @@
 					</File>
 					<File
-						RelativePath="..\..\src\orxonox\objects\infos\LevelInfo.cc"
+						RelativePath="..\..\src\orxonox\objects\infos\Level.cc"
 						>
 					</File>
@@ -405,4 +403,8 @@
 					>
 					<File
+						RelativePath="..\..\src\orxonox\overlays\hud\ChatOverlay.cc"
+						>
+					</File>
+					<File
 						RelativePath="..\..\src\orxonox\overlays\hud\HUDBar.cc"
 						>
@@ -444,60 +446,12 @@
 					RelativePath="..\..\src\orxonox\gui\OgreCEGUIRenderer.cpp"
 					>
-					<FileConfiguration
-						Name="Debug|Win32"
-						>
-						<Tool
-							Name="VCCLCompilerTool"
-							UsePrecompiledHeader="0"
-						/>
-					</FileConfiguration>
-					<FileConfiguration
-						Name="Release|Win32"
-						>
-						<Tool
-							Name="VCCLCompilerTool"
-							UsePrecompiledHeader="0"
-						/>
-					</FileConfiguration>
 				</File>
 				<File
 					RelativePath="..\..\src\orxonox\gui\OgreCEGUIResourceProvider.cpp"
 					>
-					<FileConfiguration
-						Name="Debug|Win32"
-						>
-						<Tool
-							Name="VCCLCompilerTool"
-							UsePrecompiledHeader="0"
-						/>
-					</FileConfiguration>
-					<FileConfiguration
-						Name="Release|Win32"
-						>
-						<Tool
-							Name="VCCLCompilerTool"
-							UsePrecompiledHeader="0"
-						/>
-					</FileConfiguration>
 				</File>
 				<File
 					RelativePath="..\..\src\orxonox\gui\OgreCEGUITexture.cpp"
 					>
-					<FileConfiguration
-						Name="Debug|Win32"
-						>
-						<Tool
-							Name="VCCLCompilerTool"
-							UsePrecompiledHeader="0"
-						/>
-					</FileConfiguration>
-					<FileConfiguration
-						Name="Release|Win32"
-						>
-						<Tool
-							Name="VCCLCompilerTool"
-							UsePrecompiledHeader="0"
-						/>
-					</FileConfiguration>
 				</File>
 			</Filter>
@@ -655,5 +609,5 @@
 					</File>
 					<File
-						RelativePath="..\..\src\orxonox\objects\infos\LevelInfo.h"
+						RelativePath="..\..\src\orxonox\objects\infos\Level.h"
 						>
 					</File>
@@ -734,4 +688,8 @@
 					Name="hud"
 					>
+					<File
+						RelativePath="..\..\src\orxonox\overlays\hud\ChatOverlay.h"
+						>
+					</File>
 					<File
 						RelativePath="..\..\src\orxonox\overlays\hud\HUDBar.h"
Index: /code/branches/objecthierarchy/visual_studio/vc8/orxonox.vsprops
===================================================================
--- /code/branches/objecthierarchy/visual_studio/vc8/orxonox.vsprops	(revision 2012)
+++ /code/branches/objecthierarchy/visual_studio/vc8/orxonox.vsprops	(revision 2013)
@@ -8,6 +8,6 @@
 	<Tool
 		Name="VCCLCompilerTool"
-		AdditionalOptions="/MP2"
-		PreprocessorDefinitions="ORXONOX_NO_EXPORTS;LUA_BUILD_AS_DLL"
+		AdditionalOptions="/MP2 /Zm200"
+		PreprocessorDefinitions="ORXONOX_NO_EXPORTS;ORXONOX_ENABLE_PCH;LUA_BUILD_AS_DLL"
 		UsePrecompiledHeader="2"
 		PrecompiledHeaderThrough="OrxonoxStableHeaders.h"