Index: orxonox/branches/gui/Makefile.in
===================================================================
--- orxonox/branches/gui/Makefile.in	(revision 2014)
+++ orxonox/branches/gui/Makefile.in	(revision 2015)
@@ -69,4 +69,5 @@
 LTLIBOBJS = @LTLIBOBJS@
 MAKEINFO = @MAKEINFO@
+MSBITFIELDS = @MSBITFIELDS@
 OBJEXT = @OBJEXT@
 PACKAGE = @PACKAGE@
Index: orxonox/branches/gui/configure
===================================================================
--- orxonox/branches/gui/configure	(revision 2014)
+++ orxonox/branches/gui/configure	(revision 2015)
@@ -312,5 +312,5 @@
 #endif"
 
-ac_subst_vars='SHELL PATH_SEPARATOR PACKAGE_NAME PACKAGE_TARNAME PACKAGE_VERSION PACKAGE_STRING PACKAGE_BUGREPORT exec_prefix prefix program_transform_name bindir sbindir libexecdir datadir sysconfdir sharedstatedir localstatedir libdir includedir oldincludedir infodir mandir build_alias host_alias target_alias DEFS ECHO_C ECHO_N ECHO_T LIBS INSTALL_PROGRAM INSTALL_SCRIPT INSTALL_DATA CYGPATH_W PACKAGE VERSION ACLOCAL AUTOCONF AUTOMAKE AUTOHEADER MAKEINFO AMTAR install_sh STRIP ac_ct_STRIP INSTALL_STRIP_PROGRAM AWK SET_MAKE am__leading_dot CXX CXXFLAGS LDFLAGS CPPFLAGS ac_ct_CXX EXEEXT OBJEXT DEPDIR am__include am__quote AMDEP_TRUE AMDEP_FALSE AMDEPBACKSLASH CXXDEPMODE am__fastdepCXX_TRUE am__fastdepCXX_FALSE CC CFLAGS ac_ct_CC CCDEPMODE am__fastdepCC_TRUE am__fastdepCC_FALSE CPP EGREP LIBOBJS LTLIBOBJS'
+ac_subst_vars='SHELL PATH_SEPARATOR PACKAGE_NAME PACKAGE_TARNAME PACKAGE_VERSION PACKAGE_STRING PACKAGE_BUGREPORT exec_prefix prefix program_transform_name bindir sbindir libexecdir datadir sysconfdir sharedstatedir localstatedir libdir includedir oldincludedir infodir mandir build_alias host_alias target_alias DEFS ECHO_C ECHO_N ECHO_T LIBS INSTALL_PROGRAM INSTALL_SCRIPT INSTALL_DATA CYGPATH_W PACKAGE VERSION ACLOCAL AUTOCONF AUTOMAKE AUTOHEADER MAKEINFO AMTAR install_sh STRIP ac_ct_STRIP INSTALL_STRIP_PROGRAM AWK SET_MAKE am__leading_dot MSBITFIELDS CXX CXXFLAGS LDFLAGS CPPFLAGS ac_ct_CXX EXEEXT OBJEXT DEPDIR am__include am__quote AMDEP_TRUE AMDEP_FALSE AMDEPBACKSLASH CXXDEPMODE am__fastdepCXX_TRUE am__fastdepCXX_FALSE CC CFLAGS ac_ct_CC CCDEPMODE am__fastdepCC_TRUE am__fastdepCC_FALSE CPP EGREP LIBOBJS LTLIBOBJS'
 ac_subst_files=''
 
@@ -1726,4 +1726,20 @@
 
 
+echo "$as_me:$LINENO: checking for mingw" >&5
+echo $ECHO_N "checking for mingw... $ECHO_C" >&6
+case `uname` in
+  *MINGW*)
+    mingw=yes
+    MSBITFIELDS="-mms-bitfields"
+    ;;
+  *)
+    mingw=no
+    ;;
+esac
+echo "$as_me:$LINENO: result: $mingw" >&5
+echo "${ECHO_T}$mingw" >&6
+
+
+
 # Checks for programs.
 ac_ext=cc
@@ -4953,4 +4969,7 @@
 
 fi
+
+
+LIBS="$LIBS `pkg-config --libs  gtk+-2.0`"
 
 
@@ -6439,4 +6458,5 @@
 s,@SET_MAKE@,$SET_MAKE,;t t
 s,@am__leading_dot@,$am__leading_dot,;t t
+s,@MSBITFIELDS@,$MSBITFIELDS,;t t
 s,@CXX@,$CXX,;t t
 s,@CXXFLAGS@,$CXXFLAGS,;t t
Index: orxonox/branches/gui/configure.ac
===================================================================
--- orxonox/branches/gui/configure.ac	(revision 2014)
+++ orxonox/branches/gui/configure.ac	(revision 2015)
@@ -7,4 +7,18 @@
 AC_CONFIG_SRCDIR([.])
 AC_CONFIG_HEADER([config.h])
+
+AC_MSG_CHECKING([for mingw])
+case `uname` in
+  *MINGW*)
+    mingw=yes
+    MSBITFIELDS="-mms-bitfields"
+    ;;
+  *)
+    mingw=no
+    ;;
+esac
+AC_MSG_RESULT([$mingw])
+AC_SUBST(MSBITFIELDS)
+
 
 # Checks for programs.
@@ -92,4 +106,7 @@
 AC_CHECK_LIB([m], [main])
 
+LIBS="$LIBS `pkg-config --libs  gtk+-2.0`"
+
+
 # Checks for header files.
 AC_HEADER_STDC
Index: orxonox/branches/gui/console/Makefile
===================================================================
--- orxonox/branches/gui/console/Makefile	(revision 2014)
+++ orxonox/branches/gui/console/Makefile	(revision 2015)
@@ -36,11 +36,11 @@
 PRE_UNINSTALL = :
 POST_UNINSTALL = :
-ACLOCAL = ${SHELL} /home/bensch/svn/orxonox/branches/gui/missing --run aclocal-1.7
+ACLOCAL = ${SHELL} /z/svn/orxonox/branches/gui/missing --run aclocal-1.7
 AMDEP_FALSE = #
 AMDEP_TRUE = 
-AMTAR = ${SHELL} /home/bensch/svn/orxonox/branches/gui/missing --run tar
-AUTOCONF = ${SHELL} /home/bensch/svn/orxonox/branches/gui/missing --run autoconf
-AUTOHEADER = ${SHELL} /home/bensch/svn/orxonox/branches/gui/missing --run autoheader
-AUTOMAKE = ${SHELL} /home/bensch/svn/orxonox/branches/gui/missing --run automake-1.7
+AMTAR = ${SHELL} /z/svn/orxonox/branches/gui/missing --run tar
+AUTOCONF = ${SHELL} /z/svn/orxonox/branches/gui/missing --run autoconf
+AUTOHEADER = ${SHELL} /z/svn/orxonox/branches/gui/missing --run autoheader
+AUTOMAKE = ${SHELL} /z/svn/orxonox/branches/gui/missing --run automake-1.7
 AWK = gawk
 CC = gcc
@@ -59,5 +59,5 @@
 ECHO_T = 
 EGREP = grep -E
-EXEEXT = 
+EXEEXT = .exe
 INSTALL_DATA = ${INSTALL} -m 644
 INSTALL_PROGRAM = ${INSTALL}
@@ -66,7 +66,8 @@
 LDFLAGS = 
 LIBOBJS = 
-LIBS = -lm  -lGL -lGLU -lglut
+LIBS = -lm  -lopengl32 -lGLU32 -lglut32 -Lc:/MinGW/lib -lgtk-win32-2.0 -lgdk-win32-2.0 -latk-1.0 -lgdk_pixbuf-2.0 -lpangowin32-1.0 -lgdi32 -lpango-1.0 -lgobject-2.0 -lgmodule-2.0 -lglib-2.0 -lintl -liconv  
 LTLIBOBJS = 
-MAKEINFO = ${SHELL} /home/bensch/svn/orxonox/branches/gui/missing --run makeinfo
+MAKEINFO = ${SHELL} /z/svn/orxonox/branches/gui/missing --run makeinfo
+MSBITFIELDS = -mms-bitfields
 OBJEXT = o
 PACKAGE = orxonox
@@ -82,5 +83,5 @@
 VERSION = 0.1-pre-alpha
 ac_ct_CC = gcc
-ac_ct_CXX = 
+ac_ct_CXX = g++
 ac_ct_STRIP = 
 am__fastdepCC_FALSE = #
@@ -98,5 +99,5 @@
 includedir = ${prefix}/include
 infodir = ${prefix}/info
-install_sh = /home/bensch/svn/orxonox/branches/gui/install-sh
+install_sh = /z/svn/orxonox/branches/gui/install-sh
 libdir = ${exec_prefix}/lib
 libexecdir = ${exec_prefix}/libexec
Index: orxonox/branches/gui/console/Makefile.in
===================================================================
--- orxonox/branches/gui/console/Makefile.in	(revision 2014)
+++ orxonox/branches/gui/console/Makefile.in	(revision 2015)
@@ -69,4 +69,5 @@
 LTLIBOBJS = @LTLIBOBJS@
 MAKEINFO = @MAKEINFO@
+MSBITFIELDS = @MSBITFIELDS@
 OBJEXT = @OBJEXT@
 PACKAGE = @PACKAGE@
Index: orxonox/branches/gui/gui/Makefile
===================================================================
--- orxonox/branches/gui/gui/Makefile	(revision 2014)
+++ orxonox/branches/gui/gui/Makefile	(revision 2015)
@@ -36,11 +36,11 @@
 PRE_UNINSTALL = :
 POST_UNINSTALL = :
-ACLOCAL = ${SHELL} /home/bensch/svn/orxonox/branches/gui/missing --run aclocal-1.7
+ACLOCAL = ${SHELL} /z/svn/orxonox/branches/gui/missing --run aclocal-1.7
 AMDEP_FALSE = #
 AMDEP_TRUE = 
-AMTAR = ${SHELL} /home/bensch/svn/orxonox/branches/gui/missing --run tar
-AUTOCONF = ${SHELL} /home/bensch/svn/orxonox/branches/gui/missing --run autoconf
-AUTOHEADER = ${SHELL} /home/bensch/svn/orxonox/branches/gui/missing --run autoheader
-AUTOMAKE = ${SHELL} /home/bensch/svn/orxonox/branches/gui/missing --run automake-1.7
+AMTAR = ${SHELL} /z/svn/orxonox/branches/gui/missing --run tar
+AUTOCONF = ${SHELL} /z/svn/orxonox/branches/gui/missing --run autoconf
+AUTOHEADER = ${SHELL} /z/svn/orxonox/branches/gui/missing --run autoheader
+AUTOMAKE = ${SHELL} /z/svn/orxonox/branches/gui/missing --run automake-1.7
 AWK = gawk
 CC = gcc
@@ -59,5 +59,5 @@
 ECHO_T = 
 EGREP = grep -E
-EXEEXT = 
+EXEEXT = .exe
 INSTALL_DATA = ${INSTALL} -m 644
 INSTALL_PROGRAM = ${INSTALL}
@@ -66,7 +66,8 @@
 LDFLAGS = 
 LIBOBJS = 
-LIBS = -lm  -lGL -lGLU -lglut
+LIBS = -lm  -lopengl32 -lGLU32 -lglut32 -Lc:/MinGW/lib -lgtk-win32-2.0 -lgdk-win32-2.0 -latk-1.0 -lgdk_pixbuf-2.0 -lpangowin32-1.0 -lgdi32 -lpango-1.0 -lgobject-2.0 -lgmodule-2.0 -lglib-2.0 -lintl -liconv  
 LTLIBOBJS = 
-MAKEINFO = ${SHELL} /home/bensch/svn/orxonox/branches/gui/missing --run makeinfo
+MAKEINFO = ${SHELL} /z/svn/orxonox/branches/gui/missing --run makeinfo
+MSBITFIELDS = -mms-bitfields
 OBJEXT = o
 PACKAGE = orxonox
@@ -82,5 +83,5 @@
 VERSION = 0.1-pre-alpha
 ac_ct_CC = gcc
-ac_ct_CXX = 
+ac_ct_CXX = g++
 ac_ct_STRIP = 
 am__fastdepCC_FALSE = #
@@ -98,5 +99,5 @@
 includedir = ${prefix}/include
 infodir = ${prefix}/info
-install_sh = /home/bensch/svn/orxonox/branches/gui/install-sh
+install_sh = /z/svn/orxonox/branches/gui/install-sh
 libdir = ${exec_prefix}/lib
 libexecdir = ${exec_prefix}/libexec
Index: orxonox/branches/gui/gui/Makefile.in
===================================================================
--- orxonox/branches/gui/gui/Makefile.in	(revision 2014)
+++ orxonox/branches/gui/gui/Makefile.in	(revision 2015)
@@ -69,4 +69,5 @@
 LTLIBOBJS = @LTLIBOBJS@
 MAKEINFO = @MAKEINFO@
+MSBITFIELDS = @MSBITFIELDS@
 OBJEXT = @OBJEXT@
 PACKAGE = @PACKAGE@
Index: orxonox/branches/gui/guicc/Makefile.am
===================================================================
--- orxonox/branches/gui/guicc/Makefile.am	(revision 2014)
+++ orxonox/branches/gui/guicc/Makefile.am	(revision 2015)
@@ -1,4 +1,4 @@
-AM_CXXFLAGS=`pkg-config --cflags gtk+-2.0`
-AM_LDFLAGS=`pkg-config --libs  gtk+-2.0`
+AM_CXXFLAGS=`pkg-config --cflags gtk+-2.0` $(MSBITFIELDS)
+#AM_LDFLAGS=`pkg-config --libs  gtk+-2.0`
 
 bin_PROGRAMS=gui
Index: orxonox/branches/gui/guicc/Makefile.in
===================================================================
--- orxonox/branches/gui/guicc/Makefile.in	(revision 2014)
+++ orxonox/branches/gui/guicc/Makefile.in	(revision 2015)
@@ -69,4 +69,5 @@
 LTLIBOBJS = @LTLIBOBJS@
 MAKEINFO = @MAKEINFO@
+MSBITFIELDS = @MSBITFIELDS@
 OBJEXT = @OBJEXT@
 PACKAGE = @PACKAGE@
@@ -110,7 +111,7 @@
 sysconfdir = @sysconfdir@
 target_alias = @target_alias@
-AM_CXXFLAGS = `pkg-config --cflags gtk+-2.0`
-AM_LDFLAGS = `pkg-config --libs  gtk+-2.0`
-
+AM_CXXFLAGS = `pkg-config --cflags gtk+-2.0` $(MSBITFIELDS)
+
+#AM_LDFLAGS=`pkg-config --libs  gtk+-2.0`
 bin_PROGRAMS = gui
 gui_SOURCES = orxonox_gui.cc orxonox_gui.h \
Index: orxonox/branches/gui/guicc/orxonox_gui_flags.cc
===================================================================
--- orxonox/branches/gui/guicc/orxonox_gui_flags.cc	(revision 2014)
+++ orxonox/branches/gui/guicc/orxonox_gui_flags.cc	(revision 2015)
@@ -25,6 +25,5 @@
 void OrxonoxGuiFlags::setTextFromFlags (Widget* widget)
 {
-  bzero (flagText, 1);
-
+  sprintf (flagText, "");
   strcat (flagText, "orxonox");
   FlagsText (widget);
Index: orxonox/branches/gui/src/Makefile.in
===================================================================
--- orxonox/branches/gui/src/Makefile.in	(revision 2014)
+++ orxonox/branches/gui/src/Makefile.in	(revision 2015)
@@ -69,4 +69,5 @@
 LTLIBOBJS = @LTLIBOBJS@
 MAKEINFO = @MAKEINFO@
+MSBITFIELDS = @MSBITFIELDS@
 OBJEXT = @OBJEXT@
 PACKAGE = @PACKAGE@